'From Squeak3.4gamma of ''7 January 2003'' [latest update: #5169] on 10 February 2003 at 3:38:17 pm'!
"Change Set:		8-CCFixes-ajh
Date:			10 February 2003
Author:			Anthony Hannan

This fixes some bugs found during recompileAll, like create large blocks (with > 16 captured temps) and creating a new process off a BlockClosure.  Thanks to Time Rowledge for pointing out this bug."!

Notification subclass: #UndefinedVarSignal
	instanceVariableNames: 'refNode '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Parse'!

!BlockClosure methodsFor: 'scheduling' stamp: 'ajh 2/10/2003 14:24'!
asContext
	"Create a MethodContext that is ready to execute self.  Assumes self takes no args (if it does the args will be nil)"

	^ MethodContext 
		sender: nil
		receiver: self
		method: method
		arguments: #()! !

!BlockClosure methodsFor: 'scheduling' stamp: 'ajh 2/10/2003 14:23'!
newProcess
	"Answer a Process running the code in the receiver. The process is not 
	scheduled."

	<primitive: 19> "Simulation guard"
	^ Process
		forContext: 
			[self value.
			Processor terminateActive] asContext
		priority: Processor activePriority! !


!BlockContext methodsFor: 'scheduling' stamp: 'ajh 2/10/2003 14:23'!
asContext

	^ self! !

!BlockContext methodsFor: 'scheduling' stamp: 'ajh 2/10/2003 14:25'!
newProcess
	"Answer a Process running the code in the receiver. The process is not 
	scheduled."
	<primitive: 19> "Simulation guard"
	^Process
		forContext: 
			[self value.
			Processor terminateActive] asContext
		priority: Processor activePriority! !

!BlockContext methodsFor: 'scheduling' stamp: 'ajh 2/10/2003 14:25'!
newProcessWith: anArray 
	"Answer a Process running the code in the receiver. The receiver's block 
	arguments are bound to the contents of the argument, anArray. The 
	process is not scheduled."
	<primitive: 19> "Simulation guard"
	^Process
		forContext: 
			[self valueWithArguments: anArray.
			Processor terminateActive] asContext
		priority: Processor activePriority! !


!BlockNode2 methodsFor: 'code generation' stamp: 'ajh 2/10/2003 15:12'!
emit: methodBuilder forValue: bool

	| blockMethod closureVars n |
	bool ifFalse: [^ self].  "no effect"

	compiledMethod _ nil.
	blockMethod _ self compiledMethod.
	methodBuilder mapTo: self.
	closureVars _ self freeVars.
	n _ closureVars size.
	n = 0 ifTrue: [
		"create block at compile time"
		methodBuilder pushLiteral: blockMethod createBlock.
		methodBuilder unMap.
		^ self
	].
	"create block at run time"
	methodBuilder pushLiteral: blockMethod.
	n < 16 ifTrue: [
		closureVars do: [:var | var emitDirectValue: methodBuilder reference: self].
		methodBuilder send: (BlockNode2 selectorFor: n).
		methodBuilder unMap.
		^ self
	].
	"Long form: (Array braceStream: N) nextPut: a; nextPut: b; ...; braceArray"
	(PoolVarNode new poolVariable: Array holder) referenceNode emitValue: methodBuilder.
	(ConstantNode new object: n) emitValue: methodBuilder.
	methodBuilder send: #braceStream:.
	closureVars do: [:var |
		methodBuilder doDup.
		var emitDirectValue: methodBuilder reference: self.
		methodBuilder send: #nextPut:.
		methodBuilder doPop.
	].
	methodBuilder send: #braceArray.
	methodBuilder send: #createBlockWithVars:.
	methodBuilder unMap.
! !


!CompiledMethod methodsFor: 'closure creation' stamp: 'ajh 2/10/2003 15:02'!
createBlockWithVars: array
	"Generate by the compiler to create a block closure with self as its method and array elements as its captured temps"

	| block |
	block _ (BlockClosure new: array size) method: self.
	1 to: array size do: [:i | block at: i put: (array at: i)].
	^ block! !


!SystemDictionary methodsFor: 'housekeeping' stamp: 'ajh 2/10/2003 14:37'!
recompileAll 
	"Recompile all classes"

	| n |
	Smalltalk forgetDoIts.
	n _ self classNames size.
	'Recompiling ', n printString, ' classes'
		displayProgressAt: Sensor cursorPoint from: 0 to: n
		during: [:bar |
			n _ 0.
			self allClassesDo: [:class |
				Transcript show: class name; cr.
				class compileAll.
				bar value: (n _ n + 1)]
		].

	"Smalltalk recompileAll"
! !

InstructionBuilder removeSelector: #createBlock:!
Smalltalk removeClassNamed: #CreateBlockInstr!
